#ifndef __main_cmd__
#define __main_cmd__
/*****
  command line parser interface -- generated by clig 
  (http://wsd.iitb.fhg.de/~geg/clighome/)

  The command line parser `clig':
  (C) 1995-2004 Harald Kirsch (clig@geggus.net)
*****/

typedef struct s_Cmdline {
  /***** -o: Name of the output psrfits file */
  char outfileP;
  char* outfile;
  int outfileC;
  /***** -g: Approx length in GB of output data files */
  char outlenMBP;
  int outlenMB;
  int outlenMBC;
  /***** -n: Number of LMT frequency channels */
  char nchanP;
  int nchan;
  int nchanC;
  /***** -w: Channel width (MHz) */
  char dchanP;
  double dchan;
  int dchanC;
  /***** -dt: Time resolution (us) */
  char dtP;
  double dt;
  int dtC;
  /***** -src: Source Name */
  char src_nameP;
  char* src_name;
  int src_nameC;
  /***** -raj: Source RA  (J2000) in hhmmss.ss */
  char rajP;
  double raj;
  int rajC;
  /***** -dej: Source Dec (J2000) in ddmmss.ss */
  char dejP;
  double dej;
  int dejC;
  /***** uninterpreted command line parameters */
  int argc;
  /*@null*/char **argv;
  /***** the whole command line concatenated */
  char *full_cmd_line;
} Cmdline;


extern char *Program;
extern void usage(void);
extern /*@shared*/Cmdline *parseCmdline(int argc, char **argv);

extern void showOptionValues(void);

#endif

